#include "GA.H"
#include "rand.h"
#include <windows.h>
#include <stdio.h>
#include <algorithm>
#include <fstream>

using namespace std;


class  CompGeneClass   
 {   
	public:   
	bool operator()(Gene &g1, Gene &g2);   
 };   
 bool CompGeneClass::operator()(Gene &g1, Gene &g2)
 {   
	 if(g1.get_value() <= g2.get_value()){
		 return false;
	 }
	 else
		 return true;
 }   ;

GA::GA(){
};

GA::GA(char* parafile,const NETWORK* net){

	network=net;

	GA::para=(GAPARA*)malloc(sizeof(GAPARA));

	readPara(parafile);

	InitialPop();

	run();
	
}

GA::readPara(char* parafile){

	ifstream file;
	file.open(parafile);
	int i=1;
	char temp[30];

	while(!file.eof()){
		switch (i){
		case 1:
			file>>temp;
			GA::para->exit_type=atoi(temp);
			break;
		case 2:
			file>>temp;
			GA::para->iteration_num=atoi(temp);
			break;
		case 3:
			file>>temp;
			GA::para->p_crossover=atof(temp);
			break;
		case 4:
			file>>temp;
			GA::para->p_mutation=atof(temp);
			break;
		case 5:
			file>>temp;
			GA::para->popSize=atoi(temp);
			break;
		case 6:
			file>>temp;
			GA::para->method=atoi(temp);
			break;
		default:
			printf("parafile read error!\n");
		}
		i++;
	}

	file.close();

	
}

GA::InitialPop(){

	int i=0;
	int iterNum=para->popSize*2;

	int value=-1;

	inirand();

	for(i=0;i<iterNum;i++)
	{
		Gene g;

		for(int j=0;j<network->nedge;j++){

			int rn=(network->edges+j)->RedgeNum;

			if(rn>0){
				value=randint(0,rn);
				if(value==rn){
					g.push_edge(j);
				}
				else{
					int randEdge=(network->edges+j)->RedgeId[value];
				g.push_edge(randEdge);
				}
			}
			else{
				//ͨͼӦó

			//	value=j;   
			//	int randEdge=(network->edges+j)->RedgeId[value];

				g.push_edge(j);
			}

		/*	if(value<0 || value>=network->nedge){
				printf("Ⱥʼ,λѡֵʧܣ\n");

			}
			*/

			
		}

	/*	for(int k=0;k<g.getSize();k++){
				printf("%d\t",g.gete(k));
			}
			printf("\n");
*/
		//ԻǷȷ
		if(g.getSize()!=network->nedge){
			printf("Ⱥʼʧܣ\n");

			return 0;
		}

		else{
			g.cal_value(network,para->method);

			pop.push_back(g);
		}

		

	}

}

GA::run(){

	int popSize=para->popSize;
	CompGeneClass comp;

	int randInt1;
	int randInt2;

    timePara.beginTime = GetTickCount();

	std::sort(pop.begin(), pop.end(), comp);
	actual_gen=0;

	do{
		for(int j=0;j<popSize/2;j++){

			double randf = drand();

			if(randf<para->p_mutation){

				randInt1 = randint(0, popSize-1);
                copyGene(pop[randInt1],pop[randInt1+popSize]);
				mutate(pop[randInt1+popSize]);

                pop[randInt1+popSize].cal_value(network,para->method);

			}
			else if(randf<(para->p_mutation+para->p_crossover)){

				do
				{
					randInt1 = randint(0, popSize-1);
					randInt2 = randint(0, popSize-1);
				}while(randInt1 == randInt2);

				copyGene(pop[randInt1],pop[randInt1+popSize]);
				copyGene(pop[randInt2],pop[randInt2+popSize]);

				crossover(pop[randInt1+popSize],pop[randInt2+popSize]);

				pop[randInt1+popSize].cal_value(network,para->method);
				pop[randInt2+popSize].cal_value(network,para->method);
			}
		}

/*		for(int i=0;i<popSize;i++){
			printf("%f	",pop[i].get_value());
		}
		printf("\n");
*/
		std::sort(pop.begin(), pop.end(), comp);
		actual_gen++;

		printf("this is %d generation\n",actual_gen);

	}while(para->exit_type == 0 ? actual_gen<para->iteration_num : (pop[0].get_value()-pop[popSize-1].get_value())>1e-3);

	timePara.endTime = GetTickCount();
	timePara.usedTime = timePara.endTime - timePara.beginTime;


}

GA::copyGene(Gene &g1,Gene &g2){
	int len1=g1.getSize();
	int len2=g2.getSize();

	if(len1!=len2){
		printf("ʧ\n");
	}
	else{
		for(int i=0;i<len1;i++){

			g2.sete(i,g1.gete(i));
		}

		g2.set_value(g1.get_value());
	}
}


//ĻλҪ
GA::mutate(Gene &g){


	int bitNum;
	int bitIndex;
	int bitValue;
	int neighborE;

	if((network->nedge)<20){
       bitNum=(network->nedge)/2;
	}
	else{
       bitNum=20;
	}

	for(int i=0;i<bitNum;i++){

		bitIndex=rand()%g.getSize();
		neighborE=network->edges[bitIndex].RedgeNum;

		if(neighborE>0){
			int r=randint(0,neighborE);
			if(r==neighborE){
				bitValue=bitIndex;
			}
			else{
				bitValue=network->edges[bitIndex].RedgeId[r];
			}
		}
		else{
			bitValue=bitIndex;
		}

		if(bitValue<0||bitValue>network->nedge){
			printf("mutation error!\n");
		}
		else{
			g.sete(bitIndex,bitValue);
		}

	}

}

GA::crossover(Gene &g1,Gene &g2){

	int i,j;
	std::string mask;
	mask = "" ;
	for(i = 0 ; i < g1.getSize() ; i++)
		mask += rand() % 2 + '0';
	for(i = 0; i < g1.getSize(); ++i) 
	{
		j = g1.gete(i);
		if(mask[i] == '1') {
			g1.sete(i, g2.gete(i));
			g2.sete(i, j);
		}
	}


}

GA::saveCommunity(char* outputfile,char* communityfile){

	FILE *fp = fopen(outputfile,"w+");
	FILE *c_fp = fopen(communityfile,"w+");
	if(fp == NULL)
	{
		printf("Warning: Can not open the output file!\n");
		exit(0);
	}
	if(c_fp == NULL)
	{
		printf("Warning: Can not open the community file!\n");
		exit(0);
	}

	fprintf(fp, "\n\n ------------result solution:---------------\n");

	//test
	fprintf(fp, "\n the best solutioin:\n");

	fprintf(fp, "the network has %d nodes and %d edges.\n", network->nvertexes, network->nedge);
	fprintf(fp, "the used time: %d \n", timePara.usedTime);
	fprintf(fp, "the running generation: %d\n",actual_gen);

	pop[0].print(fp,c_fp,network);
}

GA::~GA(){
};



