#include "cluster.h";
#include <algorithm>

Cluster::Cluster(){
};


int Cluster::get_e(int e){

	return c_edges[e];
};
int Cluster::get_n(){

	return c_vs.size();
};
Cluster::push_e(int e){
	c_edges.push_back(e);
};

Cluster::cal_n(const NETWORK * net){

	if(c_edges.size()==0){
		printf("ûбϢܽнʼ\n");	
	}
	else{
		std::vector<int> flag;

		for(int i=0;i<net->nvertexes;i++){
			flag.push_back(0);
		}

		for(std::vector<int>::iterator it=c_edges.begin();it!=c_edges.end();it++){
			int index=(net->edges[*it]).source;
			if(flag[index]==0){
				flag[index]=1;
				c_vs.push_back(index);
			}

			index=(net->edges[*it]).target;

			if(flag[index]==0){
				flag[index]=1;
				c_vs.push_back(index);
			}
		}


		std::sort(c_vs.begin(),c_vs.end());


	}
}

double Cluster::cal_ad(const NETWORK *net,int flag,int v){

	if(c_edges.size()==0 || c_vs.size()==0){
		printf("ųʼû\n");
	}
	else if(flag==0){

		return (double)2*c_edges.size()/c_vs.size();
	}
	else if(flag==1){
		int edge_num=0;
		for(int i=0;i<c_edges.size();i++){
			if(net->edges[c_edges[i]].source==v || net->edges[c_edges[i]].target==v){

				edge_num++;
			}
		}

		return (double)2*(c_edges.size()-edge_num)/(c_vs.size()-1);
	}
}

double Cluster::cal_cd(const NETWORK *net,int flag,int v){

	if(c_edges.size()==0 || c_vs.size()==0){
		printf("ųʼû\n");
	}
	else if(flag==0){

		return (double)2*(c_edges.size()-c_vs.size()+1)/((c_vs.size()-1)*(c_vs.size()-2));
	}
	else if(flag==1){

		int edge_num=0;
		for(int i=0;i<c_edges.size();i++){
			if(net->edges[c_edges[i]].source==v || net->edges[c_edges[i]].target==v){

				edge_num++;
			}
		}

		if( c_vs.size()==2){
			return 0;
		}
		else if(c_vs.size()==3){
			if(c_edges.size()-edge_num-c_vs.size()+2<0){
				return 1e-3;
			}
			else {
				return 0;
			}
		}

		return (double)2*(c_edges.size()-edge_num-c_vs.size()+2)/((c_vs.size()-2)*(c_vs.size()-3));

	}

}

int Cluster::getsize(){
	return c_edges.size();
}
int Cluster::get_v(int i){
	return c_vs[i];
}

bool Cluster::find_v(int v){

	for(std::vector<int>::iterator it=c_vs.begin();it!=c_vs.end();it++){
		if(*it==v){
			return true;
		}
	}
	return false;
}

Cluster::rm(const NETWORK *net,int v){
	for(std::vector<int>::iterator i=c_edges.begin();i<c_edges.end();i++){
		if(net->edges[*i].source==v || net->edges[*i].target==v){
			c_edges.erase(i);
			++i;
		}
	}

	for(std::vector<int>::iterator it=c_vs.begin();it!=c_vs.end();it++){
		if(*it==v){

			c_vs.erase(it);
			++it;
			break;
		}
	}

}

